'use strict';

var compile = require('lodash').template;
var gutil = require('gulp-util');
var through = require('through2');
var path = require('path')

var PLUGIN_NAME = 'gulp-jst';

module.exports = function(options) {

  options = options || {}
  options.ignorePath = options.ignorePath || process.cwd()

  var stream = through.obj(function(file, enc, cb) {
    if (file.isNull()) {
      this.push(file);
      return cb();
    }

    if (file.isBuffer()) {
      try {

        var hPath = path.join(path.dirname(file.path),
          path.basename(file.path, path.extname(file.path))
        )
        if (options && options.ignorePath) {
          hPath = path.relative(options.ignorePath, hPath)
        }
        file.contents = new Buffer('module.exports["'+hPath+'"] = '+compile(file.contents.toString(), null, options).source);
        file.path = gutil.replaceExtension(file.path, ".js");
      } catch(err) {
        this.emit('error', new gutil.PluginError(PLUGIN_NAME, err));
      }

      this.push(file);
      return cb();
    }

    if (file.isStream()) {
      this.emit('error', new gutil.PluginError(PLUGIN_NAME, 'Streaming not supported.'));
      return cb();
    }
  });

  return stream;
};
